VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Animation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim Spr() As SR2D_Sprite
Dim SprCnt As Long
Dim AddX As Long, AddY As Long
Dim MeSpeed As Single
Dim Phase As Single

Public Sub DrawTo(Dest As SR2D_Sprite, ByVal dx As Long, ByVal dy As Long, ByVal DT As Single, Optional ByVal Op As SR2D_Op = OpDefault)
  Phase = Phase + DT * MeSpeed
  If Phase > (SprCnt - 1) Then Phase = Phase - (Phase \ SprCnt) * SprCnt
  Dest.Draw Spr(Phase), dx + AddX, dy + AddY, Op
End Sub

Public Sub Init(ByVal CntX As Long, ByVal CntY As Long, ByVal Width As Long, ByVal Height As Long, ByVal CenterX As Long, ByVal CenterY As Long, fName As String, ByVal Speed As Single, Optional ByVal Tr As SR2D_Transform = TrNone)
  Dim SprTemp As New SR2D_Sprite
  Dim i As Long

  For i = 0 To SprCnt - 1
    Set Spr(i) = Nothing
  Next i

  SprTemp.LoadFromFile fName, Tr
  SprCnt = CntX * CntY
  AddX = -CenterX
  AddY = -CenterY
  MeSpeed = Speed

  ReDim Spr(SprCnt - 1)
  For i = 0 To SprCnt - 1
    Set Spr(i) = New SR2D_Sprite
    Spr(i).Init Width, Height, OpAlphaTest
    Spr(i).Draw SprTemp, -(i Mod CntX) * Width, -(i \ CntX) * Height, OpPaint
  Next i
End Sub

Private Sub Class_Terminate()
  Dim i As Long

  For i = 0 To SprCnt - 1
    Set Spr(i) = Nothing
  Next i
End Sub
