Attribute VB_Name = "modMain"
Option Explicit

Public Running As Boolean
Public OldTime As Double
Public NowTime As Double
Public FPS As Long

Public Const Quant As Double = 1 / 200

Public Sub Main()
  InitAll
  DoEvents
  Running = True

  Do
    OldTime = QTime
    NowTime = OldTime
    ResetControl
    PlayGame
    'Mnu
  Loop While Running

  TermAll
End Sub

Private Sub PlayGame()
  While Running
    DoEvents
    DoControl
    NowTime = QTime
    If NowTime > OldTime + Quant * 100 Then OldTime = NowTime - Quant * 100
    While NowTime > OldTime + Quant
      OldTime = OldTime + Quant
      MapTick
      PersTick
    Wend
    Render
    FPS = FPS + 1
  Wend
End Sub

Public Sub Render()
  MapDraw
  CreateTexFromSprite
  D3DRender
End Sub

Public Sub InitAll()
  Dim i As Long

  frmMain.Show
  'SoundInit frmMain.hWnd
  MapInit
  MapLoad
  MapSelect 0, 0
  D3DInit
  PersInit

  Randomize Timer
  QTimeReset 0
End Sub

Public Sub TermAll()
  PersTerminate
  D3DTerminate
  MapTerminate
  'SoundTerminate
  Unload frmMain
End Sub
